Subject: Re: bug#57434: 28.1.91; Terminal Emacs Mac OS flickering.

From: Dmitrii Kuragin <[email-masked]>
Date: Thu, 8 Sep 2022 08:59:32 -0700

I agree with Gerd on the discoveries.

Here's some code how tmux works with that [1], we can probably avoid it by
providing a frame-local flag which enables the functionality, so that
multiple emacs clients might be connected from potentially different
terminals.

We can improve the default value of the flag based on terminal capabilities
later once we have confidence in the way it works and probably extend it to
support different specifications of syncing.

[1]:
https://github.com/tmux/tmux/blob/9c34aad21c0837123a51a5a4233a016805d3e526/tty-features.c#L474

On Thu, Sep 8, 2022 at 2:35 AM Gerd Möllmann <[email-masked]>
wrote:

> Eli Zaretskii <[email-masked]> writes:
>
> > I guess by P1 you mean these two sequences:
> >
> >   BSU: ESC P = 1 s ESC \
> >   ESU: ESC P = 2 s ESC \
> >
> > whereas by P2 you mean these:
> >
> >   DECRQM: ESC [ ? 2026 $ p
> >   DECRPM: ESC [ ? 2026 ; n $ y  (with n = 0..4, and 0 or 4 means "no
> support")
> >   BSU:    ESC [ ? 2026 h
> >   ESU:    ESC [ ? 2026 l
>
> Yes, that looks like them.
>
> >
> >> > Do you happen to know where is the definitive documentation of Sync?
> >>
> >> Sorry, I don't know a definitive documentation.
> >
> > And any documentation at all?
>
> Not even that.  I tried to find something today, but nothing useful
> turned up.
>
> >
> > Anyway, given the problems usually related to querying terminals about
> > potentially unsupported features, and the general mess in this field,
> > I think our best bet is to have a function that could switch the
> > frame-update hooks between these 3 states:
> >
> >   . unused
> >   . used with P1 BSU/ESU sequences
> >   . used with P2 BSU/ESU sequences
> >
> > WDYT?
>
> Yes, something like that, I guess.
>

-- 
*If you get an email from me outside of the 9-5 it is *not* because I'm
always on or expect an immediate response from you; it is because of work
flexibility
<http://www.inc.com/john-boitnott/how-flexible-hours-can-create-a-better-work-life-balance.html>
.  Evening and weekend emails are a sign I allocated some regular working
hours for other things (such as family, gym, friends,...).  And I encourage
you to feel free to do the same.